%union {
	int t_int;
	struct Sym *t_sym;
	struct estak *t_expr;
	struct optab *t_opcd;
	struct memstk *t_mem;
}
%token	<t_opcd>	AROP	BRNS	CTR		CTRI	IN		INCDEC	INT
%token	<t_opcd>	STACK	STACKO	FSPECL	NWFSPECL	STKMEM	NWSTKMEM	ARSTK	ARSTKP
%token	<t_opcd>	JMPS	LSEGS	MOV		OUT		POP		PUSH	RET
%token	<t_opcd>	RETI	SEG		SHFTS	SNGOP	SPECL	XCHG
%token	<t_opcd>	TARGREF TEXTREF	DATAREF SEGREL	SELFREL
%token	<t_opcd>	DBYTE	DLPTR	EVEN	IF		ENDIF	GLOBL	TEXT	DATA
%token	<t_opcd>	BSS		COMM	DWORD	ASCII	ASCIZ	BLKB	BLKW
%token	<t_opcd>	END		INSRT	RADIX	PERROR	PRINT
%token	<t_opcd>	LIST	NLIST	FLOAT	DOUBLE
%token	<t_int>	REG		SREG	NUMBER	RSH		LSH		CHARAC	DELIMIT	ST
%token	<t_sym>	SYMBOL	LOCSYM
%type	<t_int>	'+'	'-'	'*'	'/'	'&'	'^'	'!'	'~'
%type	<t_int> '['	']'	'%'	'%'

%start program
%type	<t_expr>	expr	term	fact
%type	<t_sym>		symbol
%type	<t_mem>		mem
%type	<t_int>		operator	index

%{
/*
 * Copyright (C) Microsoft Corporation, 1982
 */
#include "a86.h"
static int memrel,constrel;
%}

%%

program:
		stat_list
			;
stat_list:
		stat_list statement
			{
				do_stat();
			} |
		statement
			{
				do_stat();
			} ;

statement:
		lab_list rest '\n'
			|
		lab_list '\n'
			|
		rest '\n'
			|
		lab_list symbol '=' expr '\n'
			{
				assign($2, $4);
			} |
		symbol '=' expr '\n'
			{
				assign($1, $3);
			} |
		'\n'
			|
		INSRT '"' { 
				strmod = 1;
				strptr = String;
				delimit = '"';
			}
			string '\n'
			{
				FILE *newinp;

				if ( (newinp = fopen(String,"r")) == NULL ) {
					error("Cannot open insert file ",String);
					fprintf(stderr,"cannot open insert file %s\n",String);
				} else {
					if ( istak >= MAXINSRT ) {
						error("Too many nested inserts","");
						fprintf(stderr,"Too many nested inserts\n");
						fclose(newinp);
					} else {
						inpstk[istak++] = input;
						input = newinp;
					}
				}
			} |
		error '\n'
			{
				yyerrok;
				yyclearin;
			} ;

rest:
		expr
			{
				outw($1);
			} |
		const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outw(c_value);
			} |
		MOV
			{
				if ( optyp($1) == BYTE )
					outbyte(0244);
				else
					error("syntax error","");
			} |
		MOV		mem ',' REG
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outmove($1,0,$2,$4);
			} |
		MOV		mem ',' const
			{
				word = optyp($1) == WORD;
				outbyte(0306 | word);
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outaddr($2,0);
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				if ( word )
					outw(c_value);
				else
					outb(c_value);
			} |
		MOV		mem ',' SREG
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outsmov(0,0,$2,0,reg_num[$4]);
			} |
		MOV		REG ',' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outmove($1,1,$4,$2);
			} |
		MOV		REG ',' REG
			{
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				chkreg($4,word);
				outbyte(0212 | word);
				outbyte(0300 | (reg_num[$2]<<3) | reg_num[$4]);
			} |
		MOV		REG ',' const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$2] == 16 ) << 3;
				chkreg($2,word);
				outbyte(0260 | word | reg_num[$2]);
				if ( word )
					outw(c_value);
				else
					outb(c_value);
			} |
		MOV		REG ',' SREG
			{
				outsmov(1,0,0,$2,reg_num[$4]);
			} |
		MOV		SREG ',' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outsmov(0,1,$4,0,reg_num[$2]);
			} |
		MOV		SREG ',' REG
			{
				outsmov(1,1,0,$4,reg_num[$2]);
			} | 
		PUSH	mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(0777);
				outaddr($2,6);
			} |
		PUSH	REG
			{
				chkreg($2,1);
				outbyte(0120 | reg_num[$2]);
			} |
		PUSH	SREG
			{
				outbyte(0006 | (reg_num[$2]<<3));
			} |
		POP		mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(0217);
				outaddr($2,0);
			} |
		POP		REG
			{
				chkreg($2,1);
				outbyte(0130 | reg_num[$2]);
			} |
		POP		SREG
			{
				outbyte(0007 | (reg_num[$2]<<3));
			} |
		XCHG	mem ',' REG
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$4] == 16 );
				chkreg($4,word);
				outbyte(0206 | word);
				outaddr($2,reg_num[$4]);
			} |
		XCHG	REG ',' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				outbyte(0206 | word);
				outaddr($4,reg_num[$2]);
			} |
		XCHG	REG ',' REG
			{
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				chkreg($4,word);
				if ( word &&  reg_num[$2] == AX_AL ) 
					outbyte(0220 | reg_num[$4]);
				else if ( word &&  reg_num[$4] == AX_AL ) 
					outbyte(0220 | reg_num[$2]);
				else {
					outbyte(0206 | word);
					outbyte(0300 | (reg_num[$2]<<3) | reg_num[$4]);
				}
			} |
		IN		expr
			{
				word = optyp($1) == WORD;
				outbyte(0344 | word);
				outb($2);
			} |
		IN
			{
				word = optyp($1) == WORD;
				outbyte(0354 | word);
			} |
		OUT		expr
			{
				word = optyp($1) == WORD;
				outbyte(0346 | word);
				outb($2);
			} |
		OUT
			{
				word = optyp($1) == WORD;
				outbyte(0356 | word);
			} |
		SPECL
			{
				outbyte(optyp($1));
				if ( opstyp($1) != 0 )
					outbyte(opstyp($1));
			} |
		LSEGS	REG ',' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				chkreg($2,1);
				outbyte(optyp($1));
				outaddr($4,reg_num[$2]);
			} |
		AROP
			{
				if ( opstyp($1) == I_CMP && optyp($1) == BYTE )
					outbyte(0246);
				else
					error("syntax error","");
			} |
		AROP	mem ',' REG
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$4] == 16 );
				chkreg($4,word);
				outbyte(arop_rm[opstyp($1)] | word);
				outaddr($2,reg_num[$4]);
			} |
		AROP	mem ',' const
			{
				int opt;

#ifdef RELFMTI
				Self_rel = memrel;
#endif
				if ( optyp($1) == BYTE )
					word = 0;
				else {
					opt = opstyp($1);
					if ( c_len == 8 && opt != I_OR && opt != I_AND
						&& opt != I_XOR && opt != I_TEST )
						word = 3;
					else
						word = 1;
				}
				outbyte( (opstyp($1)==I_TEST ? 0366 : 0200) | word);
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outaddr($2,opstyp($1)&7);
#ifdef RELFMTI
				Self_rel = constrel ;
#endif
				if ( word == 1 )
					outw(c_value);
				else
					outb(c_value);
			} |
		AROP	REG ',' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				if ( opstyp($1) != I_TEST )
					word |= 2;
				outbyte(arop_rm[opstyp($1)] | word);
				outaddr($4,reg_num[$2]);
			} |
		AROP	REG ',' const
			{
				int opt;

#ifdef RELFMTI
				Self_rel = constrel;
#endif
				if ( optyp($1) == BYTE || reg_len[$2] == 8 )
					word = 0;
				else {
					opt = opstyp($1);
					if ( c_len == 8 && opt != I_OR && opt != I_AND
						&& opt != I_XOR && opt != I_TEST )
						word = 3;
					else
						word = 1;
				}
				chkreg($2,word);
				if ( reg_num[$2] == AX_AL ) {
					word &= 1; /* no short constants allowed */
					outbyte(arop_ai[opstyp($1)] | word);
				} else {
					outbyte( (opstyp($1)==I_TEST ? 0366 : 0200) | word);
					outbyte(0300 | (opstyp($1)<<3) | reg_num[$2]);
				}
				if ( word == 1 )
					outw(c_value);
				else
					outb(c_value);
			} |
		AROP	REG ',' REG
			{
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				chkreg($4,word);
				if ( opstyp($1) != I_TEST )
					word |= 2;
				outbyte(arop_rm[opstyp($1)] | word);
				outbyte(0300 | (reg_num[$2]<<3) | reg_num[$4]);
			} |
		INCDEC	mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD );
				outbyte( 0776 | word);
				outaddr($2,(opstyp($1) == I_INC ? 0 : 1));
			} |
		INCDEC	REG
			{
				if ( optyp($1) == BYTE || reg_len[$2] == 8 ) {
					chkreg($2,0);
					outbyte( 0776 );
					outbyte(0300 | (opstyp($1)==I_INC ? 0 : 010) | reg_num[$2]);
				} else {
					chkreg($2,1);
					outbyte((opstyp($1) == I_INC ? 0100 : 0110) | reg_num[$2]);
				}
			} |
		SNGOP	mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD );
				outbyte( 0366 | word);
				outaddr($2,opstyp($1));
			} |
		SNGOP	REG
			{
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				outbyte( 0366 | word );
				outbyte(0300 | (opstyp($1)<<3) | reg_num[$2]);
			} |
		SHFTS	mem ',' const
			{
				word = ( optyp($1) == WORD );
				if ( eint(c_value) != 1 )
					error("Value error","");
				else {
					outbyte(0320 | word);
#ifdef RELFMTI
					Self_rel = memrel;
#endif
					outaddr($2,opstyp($1));
				}
			} |
		SHFTS	mem ',' REG
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				word = ( optyp($1) == WORD );
				if ( reg_num[$4] != CX_CL )
					error("Value error","");
				else {
					outbyte(0322 | word);
					outaddr($2,opstyp($1));
				}
			} |
		SHFTS	REG ',' const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				if ( eint(c_value) != 1 )
					error("Value error","");
				else {
					outbyte(0320 | word);
					outbyte(0300 | (opstyp($1)<<3) | reg_num[$2]);
				}
			} |
		SHFTS	REG ',' REG
			{
				word = ( optyp($1) == WORD && reg_len[$2] == 16 );
				chkreg($2,word);
				if ( reg_num[$4] != CX_CL )
					error("Value error","");
				else {
					outbyte(0322 | word);
					outbyte(0300 | (opstyp($1)<<3) | reg_num[$2]);
				}
			} |
		CTR		expr
			{
				if ( optyp($1) == I_CALL )
					outbyte(0350);
				else
					outbyte(0351);
#ifdef RELFMTI
				Self_rel = 1;
#endif
				outwrel($2);
			} |
		CTR		'@' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outaddr($3,2);
				else
					outaddr($3,4);
			} |
		CTR		'@' REG
			{
				chkreg($3,1);
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outbyte(0320 | reg_num[$3]);
				else
					outbyte(0340 | reg_num[$3]);
			} |
		CTR		REG
			{
				chkreg($2,1);
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outbyte(0320 | reg_num[$2]);
				else
					outbyte(0340 | reg_num[$2]);
			} |
		CTRI	expr ',' const
			{
				if ( optyp($1) == I_CALL )
					outbyte(0232);
				else
					outbyte(0352);
#if RELFMTI
				putc(R_TARG,object) ;	/* frame is target */
				putc(R_POFFS,object) ;  /* long pointer */
#endif
				outw($2);
				outw(c_value) ;
			} |
		CTRI	expr
			{
				if ( optyp($1) == I_CALL )
					outbyte(0232);
				else
					outbyte(0352);
#if RELFMTI
				putc(R_TARG,object) ;	/* frame is target */
				putc(R_LNPTR,object);	/* long pointer */
#ifdef DEBUG
				dbprt("trc","R_LNPTR to object %d\n",R_LNPTR) ;
#endif
				Rel_lng = 1;
				outw($2) ;
				Rel_lng = 0;
				outbyte(0) ;
				outbyte(0) ;
#else
				outw($2) ;
				outbyte(0) ;
				outbyte(0) ;
				outbyte(0) ;
				outbyte(0) ;
#endif
			} |
		CTRI	'@' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outaddr($3,3);
				else
					outaddr($3,5);
			} |
		CTRI	'@' REG
			{
				chkreg($3,1);
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outbyte(0330 | reg_num[$3]);
				else
					outbyte(0350 | reg_num[$3]);
			} |
		CTRI	REG
			{
				chkreg($2,1);
				outbyte(0777);
				if ( optyp($1) == I_CALL )
					outbyte(0330 | reg_num[$2]);
				else
					outbyte(0350 | reg_num[$2]);
			} |
		RET
			{
				outbyte(0303);
			} |
		RET		const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outbyte(0302);
				outw(c_value);
			} |
		RETI
			{
				outbyte(0313);
			} |
		RETI	const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outbyte(0312);
				outw(c_value);
			} |
		JMPS	expr
			{
				outbyte(optyp($1));
				outbrel($2);
			} |
		BRNS	expr
			{
				outbyte(optyp($1));
				outbyte(3);
				outbyte(0351);
				outwrel($2);
			} |
		BRNS	'@' mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				if ( $3->m_mod == 6 || (i=($3->m_mod>>6)&3) == 2)
					ilen = 4;
				else if (i == 1)
					ilen = 3;
				else
					ilen = 2;
				outbyte(optyp($1));
				outbyte(ilen);
				outbyte(0352);
				outaddr($3,4);
			} |
		BRNS	'@' REG
			{
				chkreg($3,1);
				outbyte(optyp($1));
				outbyte(2);
				outbyte(0352);
				outbyte(0340 | reg_num[$3]);
			} |
		BRNS	REG
			{
				chkreg($2,1);
				outbyte(optyp($1));
				outbyte(2);
				outbyte(0352);
				outbyte(0340 | reg_num[$2]);
			} |
		INT		const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				if ( etyp(c_value) == A_ABS && eint(c_value) == 3 )
					outbyte(0314);
				else {
					outbyte(0315);
					outb(c_value);
				}
			} |
		SEG		SREG
			{
				outbyte(0046 | (reg_num[$2] << 3) );
#if RELFMTI
				if(reg_num[$2] == 1)
					{
					putc(R_FTEXT,object) ;
						/* text as frame of reference */
					}
#endif
			} |
		TARGREF
			{
#if RELFMTI
				putc(R_TARG,object) ;
						/* target as frame reference */
#endif
			} |
		TEXTREF
			{
#if RELFMTI
				putc(R_FTEXT,object) ;
						/* text as frame reference */
#endif
			} |
		DATAREF
			{
#if RELFMTI
				putc(R_FDATA,object) ;
						/* data as frame reference */
#endif
			} |
		SEGREL
			{
#if RELFMTI
			Self_rel = 0;
#endif
			} |
		SELFREL
			{
#if RELFMTI
			Self_rel = 1;
#endif
			} |
		STACK		ST '(' NUMBER ')'
			{
				chkfreg($4) ;
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outbyte(opstyp($1) | $4) ;
			} |
		STACKO		ST '(' NUMBER ')'
			{
				chkfreg($4) ;
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outbyte(opstyp($1) | $4) ;
			} |
		STACKO
			{
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outbyte(opstyp($1) | 1);
				/* ST(1) is the default */
			} |
		FSPECL
			{
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outbyte(opstyp($1)) ;
			} |
		NWFSPECL
			{
				outbyte(optyp($1)) ;
				outbyte(opstyp($1)) ;
			} |
		STKMEM mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outaddr($2,opstyp($1)) ;
			} |
		NWSTKMEM mem
			{
#ifdef RELFMTI
				Self_rel = memrel;
#endif
				outbyte(optyp($1)) ;
				outaddr($2,opstyp($1)) ;
			} |
		ARSTK
			{
					/* default to st(1),st */
				outbyte(WAIT8087) ;
				outbyte(optyp($1) | 0x06) ;
					/* implied pop */
				outbyte(opstyp($1) | 1) ;
			} |
		ARSTK	ST ',' ST '(' NUMBER ')'
			{
				int i;
				chkfreg($6) ;
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				i = opstyp($1) ;
				if (i & 0x20)	/* sub or div */
					i = i ^ 0x08 ;
				outbyte(i | $6) ;
			} |
		ARSTK	ST '(' NUMBER ')' ',' ST
			{
				chkfreg($4) ;
				outbyte(WAIT8087) ;
				outbyte(optyp($1) | 0x04) ;
				outbyte(opstyp($1) | $4) ;
			} |
		ARSTKP	ST '(' NUMBER ')' ',' ST
			{
				chkfreg($4) ;
				outbyte(WAIT8087) ;
				outbyte(optyp($1)) ;
				outbyte(opstyp($1) | $4) ;
			} |
		TEXT
			{
				loc_swap(&Text,A_TEXT,R_TEXT);
			} |
		DATA
			{
				loc_swap(&Data,A_DATA,R_DATA);
			} |
		BSS
			{
				loc_swap(&Bss,A_BSS,R_BSS);
			} |
		COMM SYMBOL ',' expr
			{
				do_glb($2);
				if ( etyp($4) != A_ABS )
					error("Illegal value for COMM","");
				else {
					$2->sy_value = eint($4);
				}
			} |
		DBYTE byt_list 
			|
		DWORD wrd_list
			|
		DLPTR lng_list
			|
		ASCIZ
			{
				/* ascii and asciz added by hans,
				   Nov 5, 1981 */
				outstring();
				outbyte(0);
			} |
		ASCII
			{
				outstring();
			} |
		FLOAT
			{
				outfloat(4);
			} |
		DOUBLE
			{
				outfloat(8);
			} |
		LIST
			{
				if ( Listing == 0 )
					Listing = 1; /*turn on listing */
			} |
		NLIST
			{
				if ( Listing == 1 )
					Listing = 0; /* kill listing */
			} |
		EVEN
			{
				new_dot = (new_dot + 1) & -2;
			} |
		GLOBL glb_list
			|
		GLOBL
			|
		BLKB	expr
			{
				if ( etyp($2) == A_ABS )
					new_dot += eint($2);
				else
					error("Invalid expression for block allocation","");
			} |
		BLKW	expr
			{
				if ( etyp($2) == A_ABS )
					new_dot += 2 * eint($2);
				else
					error("Invalid expression for block allocation","");
			} |
		END expr
			{
				loc_swap(&Text,A_TEXT,R_END);
				if ( etyp($2) == A_TEXT ) 
					Entry = eint($2);
				else {
					Entry = 0;
					error("Invalid start address","");
				}
				endflag = 1; /* set flag for yylex */
			} |
		END
			{
				loc_swap(&Text,A_TEXT,R_END);
				Entry = 0;
				endflag = 1; /* set flag for yylex */
			} ;

byt_list:
		byt_list ',' expr
			{
				outb($3);
				exp = estk;
			} |
		expr
			{
				outb($1);
				exp = estk;
			} |
		byt_list ',' const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outb(c_value);
				exp = estk;
			} |
		const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outb(c_value);
				exp = estk;
			} ;

wrd_list:
		wrd_list ',' expr
			{
				outw($3);
				exp = estk;
			} |
		expr
			{
				outw($1);
				exp = estk;
			} |
		wrd_list ',' const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outw(c_value);
				exp = estk;
			} |
		const
			{
#ifdef RELFMTI
				Self_rel = constrel;
#endif
				outw(c_value);
				exp = estk;
			} ;

lng_list:
		lng_list ',' expr
			{
#if RELFMTI
				putc(R_LNPTR,object) ;	/* long pointer */
				putc(R_TARG,object) ;	/* frame is target */
				Rel_lng = 1;
				outw($3) ;
				Rel_lng = 0;
				outbyte(0) ;
				outbyte(0) ;
#else
				outw($3) ;
				outbyte(0) ;
				outbyte(0) ;
				warn("long pointers not supported","") ;
#endif
			} |
		expr
			{
#if RELFMTI
				putc(R_LNPTR,object) ;	/* long pointer */
				putc(R_TARG,object) ;	/* frame is target */
				Rel_lng = 1;
				outw($1) ;
				Rel_lng = 0;
				outbyte(0) ;
				outbyte(0) ;
#else
				outw($1) ;
				outbyte(0) ;
				outbyte(0) ;
				warn("long pointers not supported","") ;
#endif
			} ;
glb_list:
		glb_list ',' SYMBOL
			{
				do_glb($3);
			} |
		SYMBOL
			{
				do_glb($1);
			} ;

mem:
		index
			{
				c_len = 0;
				$$ = mem_com(e,$1);
			} |
		const index
			{
				$$ = mem_com(c_value,$2);
			} |
		expr
			{
				$$ = mem_com($1,0);
#ifdef RELFMTI
				memrel = Self_rel;
				Self_rel = 0;
#endif
			} |
		expr index
			{
				c_len = 16;
				$$ = mem_com($1,$2);
#ifdef RELFMTI
				memrel = Self_rel;
				Self_rel = 0;
#endif
			} ;

index:
		'(' REG ')'
			{
				if ( ($$ = indxbit[reg_num[$2]]) == 0 ) {
					error("Invalid index register","");
					YYERROR;
				}
			} |
		'(' REG ')' '(' REG ')'
			{
				int i,j;

				if ( (j = indxbit[reg_num[$2]]) == 0 ) {
					error("Invalid index register","");
					YYERROR;
				} else if ( (i = indxbit[reg_num[$5]]) == 0 ) {
					error("Invalid index register","");
					YYERROR;
				}
				$$ = j | i;
			} ;

expr:
		expr operator term
			{
				if ( do_exp($2,$1,$3) ) 
					YYERROR;
				$$ = $1;	/* result value or tree is */
				--exp;		/* left is $1 stack entry */
			} |
		term
			{
				$$ = $1;	/* return stack entry pointer */
			} ;
term:
		'+' fact
			{
				$$ = $2;
			} |
		'-' fact
			{
				eint(exp) = 0;
				etyp(exp) = A_ABS;
				if ( do_exp($1,exp,$2) )
					YYERROR;
				eint($2) = eint(exp);
				$$ = $2;
			} |
		'~' fact
			{
				if ( do_exp($1,$2,$2) )
					YYERROR;
				$$ = $2;
			} |
		fact
			{
				$$ = $1;
			} ;

fact:
		NUMBER
			{
				$$ = e = exp++;		/* next stack entry */
				eint(e) = $1;
				etyp(e) = A_ABS;	/* type absolute value*/
			} |
		'[' SYMBOL ']'
			{
				$$ = e = exp++;		/* next stack entry */
				etyp(e) = $2->sy_type
#ifdef RELFMTI
						| E_OFFS/* offset */
#endif							
							;
#ifdef RELFMTI
				Self_rel = 0;
#endif							
				if ( $2->sy_type == A_UND )
					esym(e) = $2;	/* save the symbol ptr*/
				else
					eint(e) = $2->sy_value;
							/* save symbol value */
			} |
		'{' SYMBOL '}'
			{
				$$ = e = exp++;		/* next stack entry */
				etyp(e) = $2->sy_type
#ifdef RELFMTI
						| E_BASE
#endif
							;
				if ( $2->sy_type == A_UND )
					esym(e) = $2;	/* save the symbol ptr*/
				else
					eint(e) = $2->sy_value;
							/* save symbol value */
			} |
		symbol
			{
				$$ = e = exp++;		/* next stack entry */
				etyp(e) = $1->sy_type;
				if ( $1->sy_type == A_UND )
					esym(e) = $1;	/* save the symbol ptr*/
				else
					eint(e) = $1->sy_value;
							/* save symbol value */
			} ;

operator:
		'+'		{ $$ = $1; } |
		'-'		{ $$ = $1; } |
		'*'		{ $$ = $1; } |
		'/'		{ $$ = $1; } |
		'&'		{ $$ = $1; } |
		'!'		{ $$ = $1; } |
		'^'		{ $$ = $1; } |
		RSH		{ $$ = $1; } |
		LSH		{ $$ = $1; } ;

const:
		'*' expr
			{
				c_value = $2;
				c_len = 8;
#ifdef RELFMTI
				constrel = Self_rel;
#endif
			} |
		'#' expr
			{
				c_value = $2;
				c_len = 16;
#ifdef RELFMTI
				constrel = Self_rel;
#endif
			} ;

lab_list:
		lab_list label
			|
		label
			;

label:
		SYMBOL ':'
			{
				do_sym( $1 );
				lcl_tab = 0; /* kill local symbols */
			} |
		LOCSYM ':'
			{
				do_sym( $1 );
			} ;

symbol:
		SYMBOL
			{
				$$ = $1;
			} |
		LOCSYM
			{
				$$ = $1;
			} ;

string:
		chars DELIMIT
			{
				*strptr = '\0';
				strmod = 0;
			} ;
chars:
		chars CHARAC
			{
				*(strptr++) = $2;
			} |
		/* epsilon production */
			;
