/* bndtrn.h */
#if OSTOPS20
#define INDIR           '#'             /* Indirect file char */
#else
#define INDIR           '@'             /* Indirect file char */
#endif
#define STKSIZ          0x1000          /* 4K stack needed */
#define CBVBF           512             /* Buffer size */
#define FHNUL           0               /* Null file handle */
#define FHCON           1               /* Console file handle */
#define FHERR           (-1)            /* Error code from creat, open, etc. */
#define FCODE           0x1             /* Set if the segment is a code seg */
#define FNOTEMPTY       0x2             /* Set if the segment is not empty */
#define TYSNABS         '\0'
#define TYSNSTACK       '\024'
#define TYSNCOMMON      '\030'
#define FIXUSEG         2               /* Fixup type "base" (2 bytes) */
#define FIXULONG        3               /* Fixup type "pointer" (4 bytes) */
#define FIXUWORD        1               /* Fixup type "offset" (2 bytes) */
#define SEGABS          '\0'
#define PARAPUBSEG      0x2C            /* Paragraph-aligned public segment */
#define MASKTYSNCOMBINE '\034'
#define ALGNNIL         '\0'
#define ALGNABS         '\0'            /* Absolute LSEG */
#define ALGNBYT         '\001'          /* Byte-aligned LSEG */
#define ALGNWRD         '\002'          /* Word-aligned LSEG */
#define ALGNPAR         '\003'          /* Paragraph-aligned LSEG */
#define ALGNPAG         '\004'          /* Page-aligned LSEG */
#define COMBSTK         5               /* Combine as stack */
#define COMBCOM         6               /* Combine as common */
#define SHBTOPAR        4
#define SHPNTOPAR       5
#define MASKRB          0x1FF
#define CWBOUT          1024            /* Size of output buffer in words */
#define CBBOUT          2048            /* Size of output buffer in bytes */
#define SEGMAX          255             /* Max. no. of segments */
#define SEGRGOVL        254             /* formerly SEGRGRLEOVERLAYS */
#define SEGRGRLE        255
#define GSNMAX          255             /* Max. no. of SEGDEFs */
#define GGRMAX          10              /* Max. no. of GRPDEFs */
#define SNMAX           255             /* Max. no. of SEGDEFs per module */
#define GRMAX           10              /* Max. no. of GRPDEFs per module */
#if BASCOMVER
#define EXTMAX          2048            /* Max. no. of publics per module */
#define IMAX            2048            /* Max. of SNMAX, GRMAX, and EXTMAX */
#else
#define EXTMAX          255             /* Max. no. of publics per module */
#define IMAX            255             /* Max. of SNMAX, GRMAX, and EXTMAX */
#endif
#define IOVMAX          64              /* Max. no. of overlays */
#define RLCMAX          4
#if BASCOMVER
#define PUBMAX          2048            /* Max. no. of public symbols */
#define PARTMAX         13              /* Log2(pubMax) + 2 */
#endif
#ifndef PUBMAX
#if OSMSDOS OR OSPCDOS OR OSCPM86 OR OSTOPS20
#define PUBMAX          1024            /* Max. no. of public symbols */
#define PARTMAX         12              /* Log2(pubMax) + 2 */
#endif
#if OSXENIX
#define PUBMAX          1536            /* Max. no. of public symbols */
#define PARTMAX         13              /* Log2(pubMax) + 2 */
#endif
#endif
#define LNAMEMAX        255             /* Maximum LNAME length */
#define IRHTEMAX        256
#define TYPMAX          256             /* Max. no. of TYPDEFs */
#define CSLOTMAX        37              /* No. of buckets on dictionary page */
#define THEADR          '\200'          /* Module header record */
#define LHEADR          '\202'          /* Module header record */
#define COMENT          '\210'          /* COMmENT record */
#define MODEND          '\212'          /* MODule END record */
#define EXTDEF          '\214'          /* EXTernal DEFinition record */
#define TYPDEF          '\216'          /* TYPe DEFinition record */
#define PUBDEF          '\220'          /* PUBlic DEFinition record */
#define LINNUM          '\224'          /* LINe NUMbers record */
#define LNAMES          '\226'          /* LNAMES record */
#define SEGDEF          '\230'          /* SEGment DEFinition record */
#define GRPDEF          '\232'          /* GRouP DEFinition record */
#define FIXUPP          '\234'          /* Fixup record */
#define LEDATA          '\240'          /* Logical Enumerated DATA record */
#define LIDATA          '\242'          /* Logical Iterated DATA record */
#define LIBHDR          '\360'          /* Library header record type */
#if SMALLVERSION
#define CPNMAXSYMS      120             /* Max. no. of pages in symbol table */
#define CPNMAXRLE       60              /* Max. no. of pages in reloc table */
#endif
#if LARGEVERSION
#define CPNMAXSYMS      127             /* Max. no. of pages in symbol table */
#define CPNMAXRLE       127             /* Max. no. of pages in reloc table */
#endif
#define FHNIL           0xFFFF          /* Nil library number */
#define IOVNIL          0xFFFF          /* Nil overlay number */
#define IOVROOT         0               /* Root overlay number */
#define SEGNIL          0               /* Nil segment number */
#define GRNIL           0               /* Nil group number */
#define RECTNIL         '\0'            /* Nil record type */
#define RHTENIL         0               /* Nil pointer */
#define PROPNIL         0               /* Nil pointer */
#define RPROPNIL        0               /* Nil pointer */
#define SNNIL           0               /* Nil SEGDEF number */
#define PNNIL           0xFFFF          /* Nil page number */
#define INIL            0xFFFF          /* Nil index (generic) */
#define ATTRNIL         0               /* Nil attribute */
#define ATTRPSN         1               /* Public segment attribute */
#define ATTRLSN         2               /* Local segment attribute */
#define ATTRPNM         3               /* Public name attribute */
#define ATTRLNM         4               /* Local name attribute */
#define ATTRFIL         5               /* File name attribute */
#define ATTRGRP         6               /* Group name attribute */
#define ATTRRAG         7
#define ATTRUND         8               /* Undefined symbol attribute */
#define ATTROVL         9               /* Overlay attribute */
#define ATTRMAX         10              /* Highest attribute no. plus 1 */
#define AREASYMS        1               /* Symbol table VM area number */
#define AREARGRLE       2               /* Reloc table VM area number */
#define AREAFSG         3               /* Area number of first segment */
#define AREAFLB         247             /* Area number of first library */
#define IFHLIBMAX       8               /* Max. no. of libraries */
#if OIAPX286
#define STBIAS          0x3F            /* Bias of seg. table references */
#define DFSADATA        0x27            /* Default virtual base of data */
#endif
#if LIBMSDOS
#define sbPascalLib     "\012PASCAL.LIB"
					/* Pascal library name as SBTYPE */
#endif
#if LIBXENIX
#define MAGICARCHIVE    0177545         /* Magic number for archive */
#define ARHEADLEN       26              /* Length of archive header */
#define ARDICTLEN       (2 + ARHEADLEN) /* Length of archive dictionary */
#define ARDICTLOC       (2 + ARDICTLEN) /* Offset of archive dictionary */

/* Note:  Fields in the following struct definition are defined as
*  byte arrays for generality.  On the DEC20, for instance, a byte,
*  and a word and a long all use 36 bits; on the 8086, the corresponding
*  numbers are 8, 16, and 32 bits.  It is a shame to have to define
*  the record in such a fashion, but since there is no "standard,"
*  that's the way it goes.
*/
typedef struct
  {
    BYTE                arName[14];     /* Archive name */
    BYTE                arDate[4];      /* Archive date */
    BYTE                arIDs[2];       /* Count of public symbols */
    BYTE                arMode[2];      /* Mode */
    BYTE                arLen[4];       /* Length of archive */
  }
			ARHEADTYPE;     /* Archive header type */
#endif
#define OPENR           0               /* Open for reading */
#define OPENW           1               /* Open for writing */
#define OPENRW          2               /* Open for reading and writing */
#define CBHTE           (sizeof(AHTETYPE))
					/* Size of hash table entry */
#define CBPROPSN        (sizeof(APROPSNTYPE))
#define CBPROPNAME      (sizeof(APROPNAMETYPE))
#define CBPROPFILE      (sizeof(APROPFILETYPE))
#define CBPROPGROUP     (sizeof(APROPGROUPTYPE))
#define CBPROPUNDEF     (sizeof(APROPUNDEFTYPE))
#define CBPROPRAGSN     (sizeof(APROPRAGSNTYPE))
#define CBPROPOVERLAY   (sizeof(APROPOVERLAYTYPE))
#ifndef CBPMIN
#define CBPMIN          15              /* Min. no. of VM pages needed */
#endif

typedef BYTE            AREATYPE;
typedef WORD            FTYPE;
typedef WORD            ITYPE;
typedef WORD            RATYPE;
typedef WORD            SATYPE;
typedef WORD            SEGTYPE;
typedef BYTE            ALIGNTYPE;
typedef WORD            EXTTYPE;
typedef WORD            PUBTYPE;
typedef WORD            RBTYPE;
typedef RBTYPE          *RDTYPE;
typedef WORD            IOVTYPE;
typedef WORD            SNTYPE;
typedef WORD            LNTYPE;
typedef BYTE            GRTYPE;
typedef BYTE            RECTTYPE;
typedef BYTE            CHTYPE;
typedef BYTE            MITYPE;
typedef BYTE            XCTYPE;
typedef BYTE            CLTYPE;
typedef BYTE            TYSNTYPE;
typedef BYTE            FIXUTYPE;
typedef BYTE            RLCTYPE;
typedef BYTE            *HTETYPE;
typedef BYTE            *PROPTYPE;
typedef BYTE            ATTRTYPE;
typedef BYTE            KINDTYPE;
typedef WORD            LNAMETYPE;      /* LNAME index */
#if NOT LARGEMODEL
typedef char            *POINTER;       /* Pointer */
#endif

typedef struct
  {
    char                *pb;            /* Name pointer */
    WORD                cb;             /* Name length */
  }
			SDTYPE;         /* Symbol pointer */

typedef struct                          /* Attribute hash table entry */
  {
    RBTYPE              rhteNext;       /* Virt addr of next entry */
    ATTRTYPE            attr;           /* Attribute */
    RBTYPE              rprop;          /* Virt addr of property sheet */
    BYTE                cch[1];         /* Length-prefixed symbol */
  }
			AHTETYPE;

typedef struct                          /* Property sheet */
  {
    RBTYPE              a_next;         /* Link to next entry */
    ATTRTYPE            a_attr;         /* Attribute */
    BYTE                a_rgb[1];       /* Rest of record */
  }
			APROPTYPE;

#if OXOUT OR OIAPX286
typedef struct
  {
    RBTYPE              as_next;        /* Next item in property list */
    ATTRTYPE            as_attr;        /* Attribute */
    WORD                as_cbMx;        /* Size of segment */
    WORD                as_cbPv;        /* Size of previous segment */
    BYTE                as_gsn;         /* Global SEGDEF number */
    GRTYPE              as_ggr;         /* Global GRPDEF number */
    WORD                as_rCla;        /* Pointer to segment class symbol */
    BYTE                as_iov;         /* Segment's overlay number */
    BYTE                as_tysn;        /* Segment's combinality */
    BYTE                as_fCod;        /* True if segment is code segment */
    WORD                as_rFil;        /* Pointer to segment file name */
  }
			APROPSNTYPE;    /* SEGDEF property cell */
#endif

#if OEXE
typedef struct
  {
    RBTYPE              as_next;
    ATTRTYPE            as_attr;
    WORD                as_cbMx;
    WORD                as_cbPv;
    BYTE                as_gsn;
    GRTYPE              as_ggr;
    WORD                as_rCla;
    BYTE                as_iov;
    BYTE                as_tysn;
    WORD                as_rFil;
  }
			APROPSNTYPE;
#endif

#if CALLOCATION
typedef struct
  {
    RBTYPE              an_next;
    ATTRTYPE            an_attr;
    BYTE                an_gsn;
    WORD                an_ra;
    BYTE                an_rgb[1];
  }
			APROPNAMETYPE;
#endif

#if NOT CALLOCATION
typedef struct
  {
    RBTYPE              an_next;
    ATTRTYPE            an_attr;
    BYTE                an_gsn;
    WORD                an_ra;
  }
			APROPNAMETYPE;
#endif

#if LIBMSDOS
typedef struct
  {
    RBTYPE              af_next;        /* Next in chain */
    ATTRTYPE            af_attr;        /* Attribute */
    BYTE                af_iov;         /* Overlay number */
    WORD                af_FNxt;        /* Next file in list */
    WORD                af_pn1;         /* Page to start on */
    WORD                af_ifh;         /* Library number */
    WORD                af_rMod;        /* Pointer to module name symbol */
  }
			APROPFILETYPE;  /* File property cell */
#endif

#if LIBXENIX
typedef struct
  {
    RBTYPE              af_next;        /* Next in chain */
    ATTRTYPE            af_attr;        /* Attribute number */
    BYTE                af_iov;         /* Overlay number */
    WORD                af_FNxt;        /* Next file in list */
    LFATYPE             af_lfa;         /* Starting address in file */
    WORD                af_ifh;         /* Library number */
    WORD                af_rMod;        /* Pointer to module name symbol */
  }
			APROPFILETYPE;  /* File property cell */
#endif

typedef struct
  { 
    RBTYPE              ag_next;        /* Next in chain */
    ATTRTYPE            ag_attr;        /* Attribute */
    BYTE                ag_ggr;         /* Global GRPDEF number */
  }
			APROPGROUPTYPE; /* GRPDEF property cell */

#if CALLOCATION
typedef struct
  {
    RBTYPE              au_next;        /* Next in chain */
    ATTRTYPE            au_attr;        /* Attribute */
    WORD                au_rFil;        /* Pointer to file name symbol */
    WORD                au_len;         /* Length of object in bits */
  }
			APROPUNDEFTYPE; /* Undefined symbol property cell */
#endif

#if NOT CALLOCATION
typedef struct
  {
    RBTYPE              au_next;
    ATTRTYPE            au_attr;
    WORD                au_rFil;
    BYTE                au_rgb[1];
  }
			APROPUNDEFTYPE;
#endif

typedef struct
  {
    RBTYPE              ar_next;
    ATTRTYPE            ar_attr;
  }
			APROPRAGSNTYPE;

typedef struct
  {
    RBTYPE              ao_next;        /* Next in chain */
    ATTRTYPE            ao_attr;        /* Attribute */
    BYTE                ao_iov;         /* Overlay number */
  }
			APROPOVERLAYTPE;
					/* Overlay property cell */
#if OIAPX286
typedef struct
  {
    WORD                limit;          /* Segment size - 1 */
    WORD                laddr;          /* Low word of segment lfa */
    BYTE                haddr;          /* High byte of segment lfa */
    BYTE                acc;            /* Access code */
    WORD                unused;         /* Unused */
  }
			DTABTYPE;       /* Local descriptor table(LDT) entry */
#endif
#define LOBYTE(x)       ((x) & 0377)    /* Low-order byte of 16-bit x */
#define HIBYTE(x)       (((x) >> 8) & 0377)
					/* High-order byte of 16-bit x */
#define UPPER(b)        (b >= 'a' && b <= 'z'? b - 'a' + 'A': b)
					/* Upper casing macro */
#if NOT LARGEMODEL
#define PFromO(x)       (x)             /* No-op */
#endif
#if CDEC20                              /* If DEC20 version */
#define ifhLibMac       g00000          /* DEC20 supports only 6 sig. char.s */
#define mpifhcpnHash    g00001          /* DEC20 supports only 6 sig. char.s */
#define vrprop          g00002          /* DEC20 supports only 6 sig. char.s */
#define segLast         g00003          /* DEC20 supports only 6 sig. char.s */
#define mprlcb          g00004          /* DEC20 supports only 6 sig. char.s */
#define switchSbTab     g00005          /* DEC20 supports only 6 sig. char.s */
#define mpareapvMax     g00006          /* DEC20 supports only 6 sig. char.s */
#define vrpropFile      g00007          /* DEC20 supports only 6 sig. char.s */
#define FinishVm        g00008          /* DEC20 supports only 6 sig. char.s */
#define WriteBps        g00009          /* DEC20 supports only 6 sig. char.s */
#endif                                  /* End DEC20 declarations */
#if CRLF
#define EOL             ((int)'\r')     /* End of line character */
#else
#define EOL             ((int)'\n')     /* End of line character */
#endif
#if OSMSDOS OR OSPCDOS OR OSCPM86 OR OSTOPS20
#define sbDotExe        "\004.EXE"      /* EXE file extension */
#define sbDotLib        "\004.LIB"      /* Library file extension */
#define sbDotMap        "\004.MAP"      /* Map file extension */
#define sbDotObj        "\004.OBJ"      /* Object file extension */
#endif
#if OSXENIX
#define sbDotExe        "\004.exe"      /* EXE file extension */
#define sbDotLib        "\004.lib"      /* Library file extension */
#define sbDotMap        "\004.map"      /* Map file extension */
#define sbDotObj        "\004.obj"      /* Object file extension */
#endif

