    /****************************************************************
    *                                                               *
    *                    LINKER I/O INCLUDE FILE                    *
    *                                                               *
    ****************************************************************/

#if IOMACROS                            /* If I/O macros requested */
#define InByte(f)       getc(f)         /* Read a byte from file f */
#define OutByte(f,b)    putc(b,f)       /* Write a byte to file f */
#else                                   /* Otherwise */
#define InByte(f)       fgetc(f)        /* Read a byte from file f */
#define OutByte(f,b)    fputc(b,f)      /* Write a byte to file f */
#endif                                  /* End conditional macro definition */

#if CRLF                                /* If newline is ^M^J */
#define NEWLINE(f)      fputs("\r\n")   /* Newline macro */
#else                                   /* Else if newline is ^J */
#define NEWLINE(f)      OutByte(f,'\n') /* Newline macro */
#endif                                  /* End conditional macro definition */
#if CDEC20                              /* If using DEC20 C runtime */
#define RDTXT           "r"             /* Text file */
#define RDBIN           "R"             /* Binary file */
#define WRTXT           "w"             /* Text file */
#define WRBIN           "W"             /* Binary file */
#define SETRAW(f)       _fotab[jfnof(fileno(f))]._flg |= RAW;
					/* Set file to raw mode */
#else                                   /* Else if normal runtime */
#define RDTXT           "r"             /* Text file */
#define RDBIN           "r"             /* Binary file */
#define WRTXT           "w"             /* Text file */
#define WRBIN           "w"             /* Binary file */
#define SETRAW(f)                       /* No-op */
#endif                                  /* End conditional macro definition */
#define OutSb(f,pb)     fwrite(&((BYTE *)(pb))[1],1,B2W(((BYTE *)(pb))[0]),f)
					/* Write out length-prefixed string */
extern WORD             OutWord();      /* Write a word to a file */
