#include                "dos.h"         /* Specifies conditional consts */
#if CDEC20                              /* If using DEC20 C runtime */
#define COMMENT         TRUE            /* Insure that RAW is defined */
#endif                                  /* End conditional definition */
#include                <stdio.h>       /* Standard I/O */
#if CLATTICE
#define AND             &               /* Bitwise AND */
#define OR              |               /* Bitwise OR */
#define NOT             ~               /* Bitwise NOT */
#else
#define AND             &&              /* Logical AND */
#define OR              ||              /* Logical OR */
#define NOT             !               /* Logical NOT */
#endif
#if PROFILE                             /* If generating profile */
#define LOCAL                           /* No local procedures */
#else                                   /* Else if not generating profile */
#define LOCAL           static          /* Permit local procedures */
#endif                                  /* End conditional definition */
#if ASSRTON
#define ASSERT(c)       if(!(c)) { fprintf(stderr,"!(%s)\n","c"); }
#endif
#if DEBUG
#define DEBUGVALUE(v)   fprintf(stderr,"v = %lx\n",(long) v)
#define DEBUGMSG(m)     fprintf(stderr,"%s\n",m)
#define DEBUGSB(sb)     { OutSb(stderr,sb); NEWLINE(stderr); fflush(stderr); }
#ifndef ASSERT
#define ASSERT(c)       if(!(c)) { fprintf(stderr,"!(%s)\n","c"); }
#endif
#define ENTER(f)        fprintf(stderr,"Entering \"%s\"\n","f")
#define LEAVE(f,v)      fprintf(stderr,"Leaving \"%s\"  %s = %lx\n","f","v",v)
#define RETURN(x)       { DEBUGVALUE(x); return(x); }
#else
#define DEBUGVALUE(v)
#define DEBUGMSG(m)
#define DEBUGSB(sb)
#ifndef ASSERT
#define ASSERT(c)
#endif
#define ENTER(f)
#define LEAVE(f,v)
#define RETURN(x)       return(x)
#endif
#define FOREVER         for(;;)         /* Indefinite repeat macro */
#if SIGNEDBYTE
#define B2W(x)          ((WORD)(x) & 0377)
					/* Signed 8-bit to unsigned 16-bit */
#define B2L(x)          ((long)(x) & 0377)
					/* Signed 8-bit to unsigned 32-bit */
#else
#define B2W(x)          ((WORD)(x))     /* Unsigned 8-bit to unsigned 16-bit */
#define B2L(x)          ((long)(x))     /* Unsigned 8-bit to unsigned 32-bit */
#endif
#define WORDAT(a,i)     (B2W((a)[i]) + (B2W((a)[(i) + 1]) << BYTELN))
					/* Byte-swapped WORD at a[i],a[i+1] */
#if ODDWORDLN                           /* If machine word length not 16 */
#define LO16BITS(x)     ((x) & ~(~0 << WORDLN))
					/* Macro to take low 16 bits of word */
#else                                   /* Else if normal word length */
#define LO16BITS(x)     (x)             /* No-op */
#endif                                  /* End macro definition */
#define DirtyBp(bp)     rgfDirty[bp] = TRUE
					/* Mark virtual page as changed */
#define ERCOK           0
#define MODEAPP         0x6D61
#define MODEMOD         0x6D6D
#define MODEREAD        0x6D72
#define MODEWRITE       0x6D77
#define PAGESIZE        512
#define BYTELN          8               /* 8 bits per byte */
#define WORDLN          16              /* 16 bits per word */
#define SBLEN           256             /* Max string length */

typedef unsigned short  WORD;           /* 16-bit unsigned integer */
typedef char            BYTE;           /* 8-bit (signed) integer */
typedef WORD            FHTYPE;         /* File handle */
typedef FILE            *BSTYPE;        /* Byte stream (same as file handle) */
typedef long            LFATYPE;        /* File offset */
typedef char            SBTYPE[SBLEN];  /* Character string type */
typedef int             (*PFUN)();      /* Pointer to a function */
