    /****************************************************************
    *                                                               *
    *                           NEWPAR.C                            *
    *                                                               *
    ****************************************************************/

#include                "minlit.h"      /* Types and constants */
#include                "bndtrn.h"      /* Types and constants */
#include                "bndvrt.h"      /* Virtual memory stuff */
#include                "lnkio.h"       /* Linker I/O definitions */

extern                  OpenLibrary();  /* Open a library */
extern                  Fatal();        /* Fatal error procedure */
extern                  FatalFile();
extern PROPTYPE         PropSymLookup();/* Symbol table lookup??? */
extern PROPTYPE         PropAdd();      /* Add property cell to symbol entry */
#if OSMSDOS OR OSPCDOS OR OSCPM86
extern BYTE             SCPCurrentDisk();
					/* Return letter of current drive */
#endif
#if CMDMSDOS
extern                  UpdateFileParts();

extern                  PeelFlags();
#endif

extern FTYPE            fRunFileOpen;
FTYPE                   fPauseRun;
extern RBTYPE           vrhte;
extern FTYPE            vfCreated;
extern FTYPE            vfLineNos;
extern FTYPE            vfDSAlloc;      /* Perform DS allocation */
extern FTYPE            fIgnoreCase;    /* Ignore case of alpha char.s */
extern WORD             vcln;
extern SNTYPE           vgsnLineNosPrev;
extern WORD             cparMinAlloc;
extern WORD             cparMaxAlloc;
extern RATYPE           raStart;
extern FTYPE            vfMap;          /* Produce link map */
extern SATYPE           saOrigin;
extern RBTYPE           rprop1stFile;
extern WORD             ifhLibMac;
extern RBTYPE           mpifhrhte[];
#if OSMSDOS OR OSCPM86 OR OSPCDOS
extern BYTE             mpifhchDrive[];

extern BYTE             chDriveLib;
#endif
FTYPE                   vfPascalDefaults;
extern FTYPE            fDrivePass;
RBTYPE                  vrpropTailFile;
extern RBTYPE           vrprop;
static BYTE             tooManyLibraries[] = "Too many libraries specified.\n";
					/* Error message */

    /****************************************************************
    *                                                               *
    *  SbCompare:                                                   *
    *                                                               *
    *  Compares two length-prefixed strings.  Returns zero if they  *
    *  are the same, a value less  than zero if the first precedes  *
    *  the second, and a  value greater  than zero  if the  second  *
    *  precedes the first.                                          *
    *                                                               *
    *  NOTE: When comparison is case-insensitive note that letters  *
    *  will match  regardless  of case, but, in addition, '{' will  *
    *  match '[', '|' will match '\',  '}'  will  match  ']',  and  *
    *  '~' will match '^'.                                          *
    *                                                               *
    ****************************************************************/

short                   SbCompare(ps1,ps2,fncs)
register BYTE           *ps1;           /* Pointer to symbol */
register BYTE           *ps2;           /* Pointer to symbol */
FTYPE                   fncs;           /* True if not case-sensitive */
  {
    WORD                len1;           /* Symbol length */
    WORD                len2;           /* Symbol length */
    WORD                length;         /* No. of char.s to compare */
    register WORD       ch1;            /* Character */
    register WORD       ch2;            /* Character */

    if((len1 = B2W(*ps1)) < (len2 = B2W(*ps2))) length = len1;
    else length = len2;                 /* Get smallest length */
    while(length--)                     /* While not at end of symbol */
      {
	if(*++ps1 == *++ps2) continue;  /* Nothing to do if they match */
	if(!fncs) return((short) *ps1 - *ps2);
					/* If case sensitive, return diff */
	ch1 = (BYTE) *ps1 & 0137;       /* Force char to lower case */
	ch2 = (BYTE) *ps2 & 0137;       /* Force char to lower case */
	if(ch1 != ch2) return((short) ch1 - ch2);
					/* If they don't match, return diff */
      }
    return((short) len1 - len2);        /* Longer is greater */
  }

    /****************************************************************
    *                                                               *
    *  SetPascalDefaults:                                           *
    *                                                               *
    ****************************************************************/

SetPascalDefaults()
  {
    vfDSAlloc = TRUE;                   /* Perform DS allocation */
    vfPascalDefaults = TRUE;            /* Use Pascal defaults */
  }

    /****************************************************************
    *                                                               *
    *  SetFortranDefaults:                                          *
    *                                                               *
    ****************************************************************/

SetFortranDefaults()
  {
    vfDSAlloc = TRUE;                   /* Perform DS allocation */
    vfPascalDefaults = TRUE;            /* Use Pascal defaults */
  }

    /****************************************************************
    *                                                               *
    *  SetCobolDefaults:                                            *
    *                                                               *
    ****************************************************************/

SetCobolDefaults()
  {
    vfDSAlloc = FALSE;                  /* Do not perform DS allocation */
  }

    /****************************************************************
    *                                                               *
    *  SetBasicDefaults:                                            *
    *                                                               *
    ****************************************************************/

SetBasicDefaults()
  {
    vfDSAlloc = FALSE;                  /* Do not perform DS allocation */
  }

    /****************************************************************
    *                                                               *
    *  SaveInput:                                                   *
    *                                                               *
    ****************************************************************/

SaveInput(psbFile,
#if LIBMSDOS
		  pnFirst,
#endif
#if LIBXENIX
		  lfa,
#endif
			  ifh)
BYTE                    *psbFile;       /* File name */
#if LIBMSDOS
WORD                    pnFirst;        /* Page number */
#endif
#if LIBXENIX
LFATYPE                 lfa;            /* File address */
#endif
WORD                    ifh;            /* Library number */
  {
    APROPFILETYPE       *papropFile;
    RBTYPE              rpropFilePrev;

    ENTER(SaveInput);                   /* Debug info */
#if DEBUG                               /* If debugging on */
    fprintf(stderr,"File ");            /* Message */
    OutSb(stderr,psbFile);              /* File name */
    NEWLINE(stderr);                    /* Newline */
#endif                                  /* End debugging code */
#if LIBMSDOS
    DEBUGVALUE(pnFirst);                /* Debug info */
#endif
#if LIBXENIX
    DEBUGVALUE(lfa);                    /* Debug info */
#endif
    DEBUGVALUE(ifh);                    /* Debug info */
#if OSMSDOS OR OSPCDOS OR OSCPM86
    if(!SbCompare(psbFile,"\006VM.TMP",1))
      {                                 /* If name given is VM.TMP */
	fputs("VM.TMP is an illegal file name",stderr);
	NEWLINE(stderr);
	fputs("and has been ignored",stderr);
	NEWLINE(stderr);
	fflush(stderr);
	return;
      }
#endif
    papropFile = (APROPFILETYPE *) PropSymLookup(psbFile,ATTRFIL,TRUE);
    if(!vfCreated)
      {
	for(;;)
	  {
	    /* "If we have a library and we've seen this module before,
	    *  ignore it."
	    */
	    DEBUGVALUE(papropFile->af_attr);
					/* Debug value */
	    if(papropFile->af_attr == ATTRNIL) break;
	    DEBUGVALUE(papropFile->af_ifh);
					/* Debug value */
#if LIBMSDOS
	    DEBUGVALUE(papropFile->af_pn1);
					/* Debug value */
#endif
#if LIBXENIX
	    DEBUGVALUE(papropFile->af_lfa);
					/* Debug value */
#endif
	    if(papropFile->af_attr == ATTRFIL &&
	      papropFile->af_ifh != FHNIL && papropFile->af_ifh == ifh &&
#if LIBMSDOS
	      papropFile->af_pn1 == pnFirst)
#endif
#if LIBXENIX
	      papropFile->af_lfa == lfa)
#endif
	      return;
	    papropFile = (APROPFILETYPE *)
	      ObGetVa(AREASYMS,papropFile->af_next,FALSE);
	  }
	papropFile = (APROPFILETYPE *) PropAdd(vrhte,ATTRFIL);
      }
    papropFile->af_rMod = 0;
#if LIBMSDOS
    papropFile->af_pn1 = pnFirst;
#endif
#if LIBXENIX
    papropFile->af_lfa = lfa;
#endif
    papropFile->af_ifh = ifh;
    rpropFilePrev = vrpropTailFile;
    vrpropTailFile = vrprop;
    if(!rprop1stFile) rprop1stFile = vrpropTailFile;
    else
      {
	papropFile = (APROPFILETYPE *) ObGetVa(AREASYMS,rpropFilePrev,TRUE);
	papropFile->af_FNxt = vrpropTailFile;
      }
    LEAVE(SaveInput,0xFFFF);            /* Debug info */
  }

    /****************************************************************
    *                                                               *
    *  AddLibrary:                                                  *
    *                                                               *
    *  Add a library to the search list.  Check for duplicates and  *
    *  for too many libraries.                                      *
    *                                                               *
    ****************************************************************/

AddLibrary(psbName)
BYTE                    *psbName;       /* Name of library to add */
  {
    SBTYPE              sbLib;          /* Library name */
#if OSMSDOS OR OSPCDOS OR OSCPM86
    BYTE                chDrv;          /* Library drive letter */
#endif

    ENTER(AddLibrary);                  /* Debug info */
    if(psbName[0])                      /* If name not null */
      {
#if CMDMSDOS
	PeelFlags(psbName);             /* Process any flags */
#endif
#if OSMSDOS OR OSPCDOS OR OSCPM86
	if(psbName[2] == ':' && psbName[0] == '\002')
	  {                             /* If drive spec only */
	    chDriveLib = psbName[1];    /* Save new drive letter */
	    return;                     /* And return */
	  }
	sbLib[1] = SCPCurrentDisk() + 'A';
					/* Use current drive */
	sbLib[2] = ':';                 /* Finish drive spec */
	sbLib[0] = '\002';              /* Length is two so far */
#else
	sbLib[0] = '\0';                /* Initialize length */
#endif
#if CMDXENIX
	Move(B2W(psbName[0]) + 1,psbName,sbLib);
					/* Copy the library name */
#endif
#if CMDMSDOS
	UpdateFileParts(sbLib,sbDotLib);
	UpdateFileParts(sbLib,psbName);
#if OSMSDOS OR OSPCDOS OR OSCPM86
	if(fDrivePass)
	  {
	    if(chDriveLib) sbLib[1] = chDriveLib;
	    sbLib[1] |= '\200';         /* Set a flag, of all things! */
	  }
	chDrv = sbLib[1];               /* Get drive letter */
	sbLib[1] = 'Z';
#endif
#endif
	if(PropSymLookup(sbLib,ATTRFIL,FALSE) == PROPNIL)
	  {                             /* If library not already given */
	    if(ifhLibMac >= IFHLIBMAX) Fatal(tooManyLibraries,0x60);
					/* Check for too many libraries */
	    PropSymLookup(sbLib,ATTRFIL,TRUE);
					/* Add to symbol table */
	    mpifhrhte[ifhLibMac] = vrhte;
					/* Make table entry */
#if OSMSDOS OR OSPCDOS OR OSCPM86
	    mpifhchDrive[ifhLibMac] = chDrv;
					/* Make table entry */
#endif
	    ++ifhLibMac;                /* Increment counter */
	  }
      }
    LEAVE(AddLibrary,0xFFFF);           /* Debug info */
  }
